// Datei: Phase.c
// RC5 Empfnger
// Angepasst fr den RC5 Empfang auf 433MHz
//
// Die einfachen 433MHz Module benutzen meistens Pendelempfnger.
// D.h. wenn kein Trger da ist kommt Rauschen oder eine Schwingung
// die der Pendler selbst erzeugt aus dem Empfnger. Wenn man sowas
// an die Originalschaltung zum WinAmp IR-Plugin anschlieen wrde,
// drfte sie Probleme beim lernen der Codes haben. Sie wei ja nicht
// ob dort Rauschen reinkommt oder ein Code. Das lt sich nur umgehen
// wenn der Empfnger bereits wei welche Codeform er empfangen soll.
// Kommt ein Code rein den er nicht kennt (rauschen) reagiert er nicht.
// Ich benutze wieder den RC5 Code. Um den Empfang zu erleichtern wird
// vor dem RC5 Code ein langes Sync Signal gesendet. Erst wenn das
// erkannt wurde beginnt der Empfnger den RC5 Code abzutasten.
// Der Sender selbst sendet vor dem Sync noch zwei 1 Bits die nur zum
// einschwingen des Empfngers benutzt werden. Fr die Abtastung spielen
// sie keine Rolle.
//
// Ich benutze die beiden Startbits und das ToggleBit vom RC5 Code obwohl
// sie nicht gebraucht werden. Reine Faulheit. Die Reichweite knnte durch
// weglassen evtl. erhht werden. Je weniger empfangen werden mu desto
// weniger Fehler sind bei der bertragung mglich !
//
// Holger Klabunde 
// 15.09.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "rc5wamp.h"
#include "protos.h"

// Die Bi-Phasenmodulation arbeitet folgendermaen
// Eine 1 wird durch eine Flanke 0 -> 1 definiert
// Eine 0 wird durch eine Flanke 1 -> 0 definiert
// Der Empfnger invertiert die Bits hier nicht !!!

// Die RC5-Pulsbreite betrgt 1,778ms
// IR_IN wird alle 890us abgetastet und in 2 Bits rotiert.

// Die einzig gltigen Werte sind dann
// 0x02 fr ein 1 Bit und 0x01 fr ein 0 Bit
// 0x00 sowie 0x03 sind nicht erlaubt und ein Kennzeichen
// fr keinen Empfang, auer beim Sync=0x03 


//Auflsung des Timers 4 us
//RELOAD = 890us/4us = 222
//Wegen des Programm-Overheads ist der Timer mit 222 zu lang
//und die Abtastung rutscht nach rechts ber die Flanken
//Timerwert verkrzen

#define DELAY	210
#define RELOAD  DELAY

//Werte von shift fr 0 und 1 Phasensprnge
//0x00 und 0x03 sind nicht erlaubt !! 
#define ONE	0x02
#define ZERO	0x01
#define SYNC    0x03 //0x03 nur beim suchen nach Sync erlaubt

//verzgert um 890us, sampelt dann den Eingang
//und schiebt das Bit in shift
void SampleBit()
{
 TMR0=0;
 while(TMR0<RELOAD); //Zeit abwarten
 
//Puls signalisiert Abtastung zum Debugging/Abgleich mit Oszi !
//Am besten im Code lassen um das Timing nicht neu
//einstellen zu mssen

 PULS_ON();  //Fr Debugging
 PULS_OFF();

 shift<<=1;      //alte Bits nach links schieben
 if(IR_IN==1)
  {
   shift|=0x01;  //Wert war positiv, merken !!
  }//IR_IN sampeln und 1 Bits einfgen
  
 shift&=0x03;    //Nur die letzten beiden Bits sind gltig
}

//RC5 Code empfangen
unsigned char PhaseDemod()
{
 unsigned char mask,i;

 shift=0;
 comcode=0; //Kommando-Code lschen

 //Warten auf die ein Bit lange Sync Phase
 do
  {
   while(IR_IN==0); //Warten auf positive Flanke
   //1/2Bit Versatz in die Abtastung bringen, damit nicht zu dicht
   //an den Flanken abgetastet wird
   TMR0=0;
   while(TMR0<(DELAY>>1)); //Zeit abwarten

   PULS_ON();  //Fr Debugging
   PULS_OFF();
     
   if(IR_IN==0) { shift=0; } //Erste Abtastung vornehmen
   else { shift=0x01; }      

   if(shift==0x01) //wir suchen nach einer ersten 1 !
    { SampleBit(); } //Zweite Abtastung mit TMR0

  }while(shift!=SYNC);

//Erstes Startbit
 SampleBit(); //Erste Abtastung
 SampleBit(); //Zweite Abtastung
 if(shift!=ONE) return 0; //War kein Startbit, dann raus hier

//Zweites Startbit oder MSB von Extended RC5
 SampleBit(); //Erste Abtastung
 SampleBit(); //Zweite Abtastung
 if(shift!=ONE && shift!=ZERO) return 0; //War kein Startbit, dann raus hier
 if(shift==ZERO) comcode=0x40; //Extended RC5 !

//Beginn ToggleBit
 SampleBit(); //Erste Abtastung
 SampleBit(); //Zweite Abtastung
 if(shift!=ONE && shift!=ZERO) return 0; //Kein gltiges Bit, dann raus hier
 toggle=shift; //Togglebit merken
//Ende ToggleBit

//Beginn Sub-Code
//Hier kommt der 5 Bit Gertecode
 subcode=0; //Alten Sub-Code lschen
 mask=0x10; //Zum reinodern von 1 Bits, Beginn bei MSB

 for(i=0; i<5; i++)
  {
   SampleBit(); //Erste Abtastung
   SampleBit(); //Zweite Abtastung
   if(shift!=ONE && shift!=ZERO) return 0; //Kein gltiges Bit, dann raus hier

   if(shift==ONE) subcode|=mask; //Eins Bits in Subcode einfgen
   
   mask>>=1; //Nchstes Bit
  }
//Ende Sub-Code

//Beginn Kommando-Code
//Hier kommt der 6 Bit Kommandocode
 mask=0x20; //Zum reinodern von 1 Bits, Beginn bei MSB

 for(i=0; i<6; i++)
  {
   SampleBit(); //Erste Abtastung
   SampleBit(); //Zweite Abtastung
   if(shift!=ONE && shift!=ZERO) return 0; //Kein gltiges Bit, dann raus hier

   if(shift==ONE) comcode|=mask; //Eins Bits in Kommandocode einfgen
   mask>>=1; //Nchstes Bit
  }
//Ende Kommando-Code
  
 return 1; //Flag RC5-Code empfangen
}
